<?php

namespace Microsoft\Graph\Generated\Communications\CallRecords\Item\Organizer_v2;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * Identity of the organizer of the call. This relationship is expanded by default in callRecord methods.
*/
class Organizer_v2RequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new Organizer_v2RequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
